<script setup lang="ts">
import { ref } from 'vue'

import { type Country } from '@/pages/home/interfaces/IContinentCountry'
import { defaultCountry } from './interfaces/constans'

import PrincipalLayout from '@/layouts/PrincipalLayout.vue'
import IconSearch from '@/components/icons/IconSearch.vue'
import ContinentsComponent from './components/ContinentsComponent.vue'
import CountriesComponent from './components/CountriesComponent.vue'
import CountryModalComponent from './components/CountryModalComponent.vue'

import { useQueries } from './composables/useQueries'
import { useFilter } from './composables/useFilter'
import { useSelection } from './composables/useSelection'

const showContinets = ref(false)
const countrySelected = ref<Country>(defaultCountry)
const searchFilter = ref('')

const { countriesWithFlag, continentsWithImg } = useQueries()
const { selectedContinents, changeSelection, cleanFilter } = useSelection(continentsWithImg)
const { filteredCountries } = useFilter(countriesWithFlag, searchFilter, selectedContinents)

const closeModal = () => {
  showContinets.value = false
}

const showCountryModal = (country: Country) => {
  countrySelected.value = country
}
</script>

<template>
  <PrincipalLayout>
    <template #main>
      <span v-if="showContinets" v-on:click="closeModal" class="overlay"></span>
      <section class="search">
        <form @submit.prevent>
          <article>
            <div class="search-left">
              <p>País</p>
              <input
                type="search"
                @focus="showContinets = true"
                placeholder="Buscar..."
                id="search-id"
                v-model="searchFilter"
              />
            </div>
            <label class="search-right" type="submit" for="search-id"><IconSearch />Buscar</label>
          </article>
        </form>
        <section class="continents" v-if="showContinets">
          <div class="continents-options">
            <p>Filtrar continentes</p>
            <button @click="cleanFilter">Limpiar</button>
          </div>
          <section class="continents-list">
            <ContinentsComponent
              :continentsWithImg="continentsWithImg"
              @toggleSelection="changeSelection"
            >
            </ContinentsComponent>
          </section>
        </section>
      </section>
      <section class="countries" v-if="countriesWithFlag.length">
        <CountriesComponent :countries="filteredCountries" @selectCountry="showCountryModal" />
      </section>
      <CountryModalComponent
        v-if="countrySelected && countrySelected.landscape"
        :country="countrySelected"
        @showCountryModal="showCountryModal(defaultCountry)"
      />
    </template>
  </PrincipalLayout>
</template>

<style scoped>
.search-left {
  width: 200px;
}

.search-left input {
  background-color: transparent;
  outline: none;
  border-color: transparent;
}

.search-left input:focus {
  border-bottom: 2px solid var(--color-4);
}

.search-right {
  background-color: var(--color-2);
  border: none;
  outline: none;
  cursor: pointer;
  border-radius: 10px;
  color: var(--color-6);
  display: flex;
  align-items: center;
  justify-content: center;
  padding: 0 5px;
  gap: 5px;
}

form {
  display: flex;
  justify-content: center;
  align-items: center;
  margin: 20px 0;
}

form article {
  background-color: var(--color-3);
  display: flex;
  justify-content: space-between;
  padding: 10px;
  width: 60%;
  border-radius: 15px;
  border: 1px solid var(--color-4);
}

.search {
  position: relative;
}

.continents {
  position: absolute;
  width: 60%;
  left: 50%;
  transform: translateX(-50%);
  background-color: var(--color-3);
  padding: 10px;
  border-radius: 15px;
  z-index: 10;
  display: flex;
  flex-direction: column;
  border: 1px solid var(--color-4);
  box-shadow: 0 0 10px var(--color-4);
}

.continents-options {
  display: flex;
  justify-content: space-between;
  padding: 5px;
  margin-bottom: 10px;
}

.continents-options button {
  background-color: transparent;
  border: none;
  outline: none;
  cursor: pointer;
  color: var(--color-1);
  font-weight: bold;
  font-size: 1rem;
}

.continents-options button:hover {
  color: var(--color-4);
}

.continents-list {
  display: grid;
  grid-template-columns: repeat(auto-fill, minmax(180px, 1fr));
  gap: 20px;
  top: 100%;
  left: 0;
  width: 100%;
}

.countries {
  display: grid;
  grid-template-columns: repeat(auto-fill, minmax(220px, 1fr));
  gap: 20px;
  padding: 20px;
}

.overlay {
  position: absolute;
  height: 100%;
  width: 100%;
  left: 0;
  z-index: 1;
  opacity: 0;
}

@media screen and (max-width: 1080px) {
  form article {
    width: 100%;
  }

  .continents {
    width: 100%;
  }
}
</style>
